// ZipTest.cs created with MonoDevelop
// User: john at 9:09 A 20/04/2008
//
//   This file is part of the Maximum Library.
//
//   Maximum is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Maximum is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Maximum.  If not, see <http://www.gnu.org/licenses/>.
//

using System;

using NUnit.Framework;

namespace Maximum
{
	[TestFixture]
	public class ZipTest
	{
		public ZipTest()
		{
		}

		[Test]
		public void TestZipIsZIP()
		{		
			Assert.IsTrue(ZIP.IsZip("12345"));
			
			Assert.IsTrue(ZIP.IsZip("12345-1234"));
			Assert.IsTrue(ZIP.IsZip("123451234"));
			
			Assert.IsFalse(ZIP.IsZip("ABCDE"));
			Assert.IsFalse(ZIP.IsZip("ABCDE"));
			
			Assert.IsTrue(ZIP.IsZip("12345", "1234"));
			Assert.IsFalse(ZIP.IsZip("12345", "----"));
			Assert.IsTrue(ZIP.IsZip("123451234"));
			Assert.IsTrue(ZIP.IsZip("12345", ""));			
		}
		
		[Test]
		public void TestZipParse()
		{
			ZIP zip = ZIP.Parse("12345");
			Assert.AreEqual(zip.Zip5, 12345);
			zip = ZIP.Parse("12345");
			Assert.AreEqual(zip.Zip5, 12345);
			Assert.AreEqual(zip.ToInt() , 123450000);
		
			zip = ZIP.Parse("12345-1234");
			Assert.AreEqual(zip.Zip5, 12345);
			Assert.IsTrue(zip.HasPlus4);
			Assert.AreEqual(zip.Plus4, 1234);
			Assert.AreEqual(zip.ToInt(), 123451234);
			
			zip = ZIP.Parse("123451234");
			Assert.AreEqual(zip.Zip5, 12345);
			Assert.AreEqual(zip.Plus4, 1234);
			Assert.AreEqual(zip.ToInt(), 123451234);
			
			zip = ZIP.Parse("12345", "1234");
			Assert.AreEqual(zip.Zip5, 12345);
			Assert.IsTrue(zip.HasPlus4);
			Assert.AreEqual(zip.Plus4, 1234);
			Assert.AreEqual(zip.ToInt(), 123451234);			
		}
	}
}
